package ca.recrown.islandsurvivalcraft.interaction.commands;

import java.util.Arrays;
import java.util.HashSet;

import org.bukkit.ChatColor;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;

import ca.recrown.islandsurvivalcraft.IslandSurvivalCraft;

public class CommandProcessor implements CommandExecutor {
    private IslandSurvivalCraft islandSurvivalCraft;
    private HashSet<Commands> initializedCommands = new HashSet<>();

    public CommandProcessor(IslandSurvivalCraft islandSurvivalCraft) {
        this.islandSurvivalCraft = islandSurvivalCraft;
    }

    @Override
    public boolean onCommand(CommandSender sender, Command command, String label, String[] args) {
        if (args.length < 1 || args[0].isEmpty()) return false;
        Commands currentCommand = null;
        try {
            currentCommand = Commands.valueOf(args[0].toUpperCase());
        } catch (IllegalArgumentException e) {
            sender.sendMessage(ChatColor.LIGHT_PURPLE + "This command was not understood. Refer to \"/IslandSurvivalCraft help\" for more info.");
        }
        if (initializedCommands.add(currentCommand)) currentCommand.initialize(islandSurvivalCraft);
        String[] commandArguments = Arrays.copyOfRange(args, 1, args.length);
        boolean success = currentCommand.invoke(sender, commandArguments);
        if (!success) sender.sendMessage(String.format("The command arguments were incorrect. Please refer to \"/IslandSurvivalCraft help %s\" for help.", currentCommand.toString()));
        return true;
    }
}