package ca.recrown.islandsurvivalcraft.interaction.commands;

import ca.recrown.islandsurvivalcraft.interaction.commands.runnables.HighlightIslandCommand;

import org.bukkit.command.CommandSender;

import ca.recrown.islandsurvivalcraft.IslandSurvivalCraft;
import ca.recrown.islandsurvivalcraft.interaction.commands.runnables.CommandRunnable;
import ca.recrown.islandsurvivalcraft.interaction.commands.runnables.HelpCommand;

public enum Commands implements CommandRunnable {
    HIGHLIGHT(new HighlightIslandCommand()),
    HELP(new HelpCommand()),
    ;

    private final CommandRunnable commandRunnable;
    private boolean initialized = false;

    private Commands(CommandRunnable runnable) {
        this.commandRunnable = runnable;
    }

    @Override
    public String toString() {
        return name().toLowerCase();
    }

    @Override
    public boolean invoke(CommandSender sender, String[] args) {
        return commandRunnable.invoke(sender, args);
    }

    @Override
    public void initialize(IslandSurvivalCraft islandSurvivalCraft) {
        if (initialized) throw new IllegalStateException("Command already initialized.");
        initialized = true;
        commandRunnable.initialize(islandSurvivalCraft);
    }

    @Override
    public String getDescription() {
        return commandRunnable.getDescription();
    }

    @Override
    public String getDetailedDescription() {
        return commandRunnable.getDetailedDescription();
    }

}